/*  pd2fetch.c       eej      11/00    reads PDATS 2 traces for dineroIII simulator    Modify dinero source as follows:        1.  In main.c, insert a call to initPDATS          after the existing call to init(...).      2.  In fetch.c, replace "readflag = sscanxx(linebuffer,labelp,addrp);"          with "readflag = pd2fetch(labelp, addrp)"    You might also want to add the following to main.c to indicate the    modification:      printf("---PDATS 2 input by E.E. Johnson.\n");*/#include <stdio.h>#define DATA_STREAMS 2static unsigned long DataAddr[DATA_STREAMS];static unsigned long PC;static int DefaultInstrStride = 4;static int DefaultInstrShift = 2;  /* log2 of DefaultInstrStride */static int NumRep;static int DEBUG = 0;/*********************************************************************/initPDATS(){  int c, i;  if (getchar() != 0xff) {    printf(stderr, "initPDATS: file not in PDATS format\n");    exit(-1);  }  switch(c = getchar()) {  case 0x8a:      /* PDATS 2 */  /* the next four are the original PDATS formats */  case 3:         /* time stamps, w/repeats  */  case 2:         /* time stamps, no repeats */  case 1:         /* no time stamps, w/repeats  */  case 0:         /* no time stamps, no repeats */    break;  default:    fprintf(stderr, "initPDATS: PDATS format not recognized\n");    exit(-2);  }  for(i = 0; i < DATA_STREAMS; i++)    DataAddr[i] = 0;    NumRep = 0;  PC = 0;    return c;  /* so main() can call correct fetch routine */}/**************************************************************/static longNegNum(unsigned long num, int size){  switch (size) {  case 0:  case 4:  case 5:  case 6:  case 7:    return 0;  case 1: return (num & 0x80);  case 2: return (num & 0x8000);  case 3: return (num & 0x80000000);  default:    fprintf(stderr, "\npd2fetch:  illegal size (%d) passed to NegNum\n",	    size);    exit(-1);  } }/****************************************************************/#define neg1 0xffffff00#define neg2 0xffff0000static longSignExtend(long num, char size){    if (size==1) return (num | neg1);    if (size==2) return (num | neg2);    else return num;}/**************************************************************/intpd2fetch(int *labelp, int *addrp){  int i, c, d, addrCode, addr, dataStream;  long addrOffset;  /* emit sequential I-fetch if appropriate */  if (NumRep--) {  /* post-decrement overwritten if initially 0 */    *labelp = 2;    *addrp = (PC += DefaultInstrStride);    return 2;  }    /* otherwise, read a new record from the trace file */  if ((c = getchar()) != EOF) {    if (c & 0x80) {  /* PDATS 2 data record */      NumRep = (c & 0x30) >> 4;      dataStream = (c & 8) >> 3;      addr = DataAddr[dataStream];      addrCode = (c & 0x07);      /* compute offset */      switch (addrCode) {      case 0:  addr += 4;      break;      case 4:  addr -= 8;      break;      case 5:  addr -= 4;      break;      case 6:  /* no change */ break;      case 7:  addr += 8;      break;      case 1:  /* 1 byte offset */      case 2:  /* 2 byte offset */	addrOffset = 0;	for (i = addrCode; i > 0; i--) {	  d = getchar();	  addrOffset |= d << ((i-1) << 3);	}	if ( NegNum(addrOffset, addrCode) )	  addrOffset = SignExtend(addrOffset, addrCode);	addr += addrOffset;	break;      case 3:  /* 4 byte offset */	addrOffset = 0;	for (i = 4; i > 0; i--) {	  d = getchar();	  addrOffset |= d << ((i-1) << 3);	}	addr += addrOffset;	break;      }      /* update address, write return values */      *addrp = DataAddr[dataStream] = addr;      if (c & 0x40) *labelp = 1;  /* write */      else          *labelp = 0;  /* read  */    }    else {  /* instr record */      NumRep = (c >> 2) & 31;      addrCode = (c & 0x03);      if (addrCode == 0) {	addrOffset = DefaultInstrStride;      }      else {	if (addrCode == 1 || addrCode == 2) {	  addrOffset = 0;	  for(i = addrCode; i > 0; i--) {	    d = getchar();	    addrOffset |= d << ((i-1) << 3);	  }	  if (NegNum(addrOffset, addrCode))	    addrOffset= SignExtend(addrOffset, addrCode);	}	else {	  for(i = 4; i > 0; i--) {	    d = getchar();	    addrOffset |= d << ((i-1) << 3);	  }	}	addrOffset <<= DefaultInstrShift;      }      *labelp = 2;      *addrp = (PC += addrOffset);    }    return 2;  }  else return EOF;}